#include <windows.h>
#include <winbase.h>
#include <stdio.h>
#include <conio.h>
#include "misc.h"
#include "CommLine.h"

void MoveBuffer(char *buffer,int start,int direct)
{
	char	tmp[CL_BUFF_SIZE];
	
	memcpy(tmp,buffer,CL_BUFF_SIZE);
	memcpy(buffer + start + direct,tmp + start,CL_BUFF_SIZE - start - 1);
}


void CommandLineServis(TCommandLine *cl,char key,int virtkey,DWORD controlKeyState)
{
	char stmp[CL_BUFF_SIZE];
	
	gotoxy(cl->x,cl->y);
		switch(virtkey)
		{
//LEFT
			case 37 : {
						//word left
						if((controlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
						{
							if(cl->bufpos>0) 
							{
								char *p = cl->buffer;
								for(int i = cl->bufpos; p[i] != ' ' && i != 0; i--);
								if(i)
								{
									//goto next word
									int diff = cl->bufpos - i + 1;
									cl->x -= diff;
									cl->bufpos -= diff;
								}
								else
								{
									//goto begin
									cl->x = cl->startx;
									cl->bufpos = 0;
								}
			
							}
						}
						else
						{
					//one char left
							if(cl->bufpos>0) 
							{
								cl->x--;
								cl->bufpos--;
							}
						}
						break;
					  }
//RIGHT
			case 39 : {
						//word left
						if((controlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED) )) 
						{
							if(cl->bufpos<strlen(cl->buffer)) 
							{
								char *p = strchr(cl->buffer+cl->bufpos,' ');
								if(p)
								{
									//goto next word
									short diff = p - cl->buffer - cl->bufpos + 1;
									cl->x += diff;
									cl->bufpos += diff;
								}
								else
								{
									cl->x = cl->startx + strlen(cl->buffer);
									cl->bufpos = strlen(cl->buffer);
								}
							}							
						}
						else
						{
							if(cl->bufpos < strlen(cl->buffer)) 
							{
								cl->bufpos++;
								cl->x++;
							}
						}
						break;
					  }
//BACKSPACE
			case 8 : {
						if(cl->bufpos>0) 
						{
							MoveBuffer(cl->buffer,cl->bufpos,-1);
							cl->buffer[strlen(cl->buffer)] = 0;
							cl->bufpos--;
							cl->x--;
						}
						break;
					  }
//DELETE
			case 46 : {
						if(cl->bufpos < strlen(cl->buffer)) 
						{
							MoveBuffer(cl->buffer,cl->bufpos+1,-1);
							cl->buffer[strlen(cl->buffer)] = 0;
						}
						break;
					  }
//HOME
			case 36 : {
						cl->x = cl->startx;
						cl->bufpos = 0;
						break;
					  }
//END
			case 35 : {
						cl->x = cl->startx + strlen(cl->buffer);
						cl->bufpos = strlen(cl->buffer);
						break;
					  }
		}//switch
		if(isprint(key))
		{
			if(cl->bufpos < cl->size)
			{
				if(strlen(cl->buffer) < cl->size)
				{
					MoveBuffer(cl->buffer,cl->bufpos,1);
					cl->buffer[cl->bufpos] = (char)key;
					cl->bufpos++;
					cl->x++;
				}
			}
		}

//refresh screen
		gotoxy(0,cl->starty);
		memset(stmp,' ',99);
		stmp[cl->size - strlen(cl->buffer)] = 0;
		printf("KC>%s%s",cl->buffer,stmp);
		gotoxy(cl->x,cl->y);
}
