#ifndef		KWINDOW_H
#define		KWINDOW_H

#include <windows.h>
#include "globals.h"

class KWindow {
	HANDLE hCon;
public:

	char		label[STR_SIZE];
	short		posX,posY,sizeX,sizeY,colorT,colorB;
	BOOL		visible;
	BOOL		shadow;
	short		curSelRow;
	COORD		dwBufferSize,dwBufferCoord;	//for bg
	SMALL_RECT	srReadRegion;			
	CHAR_INFO	*lpBgBuffer;				//buffer for bg

	void gotoxy(SHORT x, SHORT y);

	KWindow(HANDLE hStdOut); 
	~KWindow(); 

	void SetPos(short x,short y);
	short GetPosX() {return posX;};
	short GetPosY() {return posY;};
	void SetSize(short x,short y);
	short GetSizeX() {return sizeX;};
	short GetSizeY() {return sizeY;};
	void SetTC(short c);
	void SetBC(short c);
	void Init(char *text,short px,short py,short sx,short sy,short tc,short bc,BOOL shadowp = FALSE);
	void SetLabel(char *label);

	void SaveBG(void);
	void RestoreBG(HANDLE hConsole = 0);
	void DrawFrame(HANDLE hConsole);
	void Show(HANDLE hConsole);
	void Hide(void);

	BOOL WriteRow(HANDLE hConsole,int iRow,LPCTSTR lpRow,short tc = -1,short bc = -1);
	int SetAttributes(int x,int y,int size,short tc,short bc);
	int RowAttribute(int iRow,short tc = -1,short bc = -1);
	int RowAttributeCon(HANDLE hConsole,int iRow,short tc = -1,short bc = -1);
};

#endif