#ifndef MISC__H
#define MISC__H

#include "globals.h"

#define kASSERT(a) assert(a)

#define		WIN_NT			1
#define		WIN_95			2
#define		WIN_32S			3
extern DWORD dwOSVersion;

void GetOSVersion(void);
void KulakSleep(DWORD ms);
void SpeekerBeep(int n);
void gotoxy(int x,int y);
void clprintf(HANDLE hCon,const short ct,const short cb,const short x,const short y,char *str,...);
void CopyConsoleScreen(HANDLE dest,HANDLE src);
void CopyConsoleWindow(HANDLE dest,HANDLE src,WORD x,WORD y, WORD xs, WORD ys);
void ReadAttribute(HANDLE hCon,WORD *attr,short x,short y,unsigned size);
void WriteAttribute(HANDLE hCon,WORD *attr,short x,short y,unsigned size);
void SetAttribute(HANDLE hCon,short ct,short cb,short x,short y,unsigned size);
BOOL TestDir(char *dir);
void DeleteLastBackslash(char *str);
void FormatStringRight(DWORD size,char *str);
void CreateSpaceString(char *dest,char *src,int size);
void StringLeftOrRight(char *left,char *right,int size);
BOOL get_2parts_from_end(char *s,char *part1,char *part2,char separator,BOOL b_ret_empty = FALSE);
int mygetch(void);
int mygetchVK(void);
int mygetchASCII(void);
BOOL SetCursor(HANDLE h,BOOL visible,DWORD size);
void StrCut2Dot(char * str,int maxsize);
BOOL PutBlockToClipboard(char *buffer,long size);
long GetBlockFromClipboard(char*& buffer);
void HideCursor(HANDLE h,BOOL hide);

BOOL MyGetFileTime(char *fname,LPFILETIME ct,LPFILETIME lat,LPFILETIME lwt);
BOOL MySetFileTime(char *fname,LPFILETIME ct,LPFILETIME lat,LPFILETIME lwt);

#endif