#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <string.h>
#include <time.h>
#include "File.h"
#include "globals.h"
#include "misc.h"
#include "reminder.h"

long	g_kc_debug = 0;

TPanel filePanel1;
TPanel filePanel2;
TPanel findPanel;			//find panel
TPanel netPanel;			//network panel
TPanel taskPanel;			//tasks panel

LPNETRESOURCE netResource=NULL;

TPanel *pLeftPanel = &filePanel1;
TPanel *pRightPanel = &filePanel2;

char lDirectory[STR_SIZE];
char rDirectory[STR_SIZE];
char *aDirectory;

char about[STR_SIZE];

int ActivePanel = LEFT;	//active panel flag
TPanel *(*aPanel);		//active panel pointer
KWindow *aWindow;		//active window

TFindHead ffHead;

char	g_ini_file[STR_SIZE];
char	g_start_path[STR_SIZE];

t_ext g_fext_run[100];
t_ext g_fext_edit[100];
t_ext g_fext_view[100];
int g_n_fext_run;
int g_n_fext_edit;
int g_n_fext_view;

bool InitPanels()
{
	filePanel1.f1 = true;
	filePanel1.f2 = true;
	filePanel1.f3 = true;
	filePanel1.f4 = true;
	filePanel1.f5 = true;
	filePanel1.f6 = true;
	filePanel1.f7 = true;
	filePanel1.f8 = true;
	filePanel1.f9 = true;
	filePanel1.f10 = true;
	filePanel1.f11 = true;
	filePanel1.f12 = true;
	filePanel1.ctrl_f1 = true;
	filePanel1.ctrl_f2 = true;
	filePanel1.ctrl_f3 = true;
	filePanel1.ctrl_f4 = true;
	filePanel1.ctrl_f5 = true;
	filePanel1.ctrl_f6 = true;
	filePanel1.ctrl_f7 = true;
	filePanel1.ctrl_f8 = true;
	filePanel1.ctrl_f9 = true;
	filePanel1.ctrl_f10 = true;
	filePanel1.ctrl_f11 = true;
	filePanel1.ctrl_f12 = true;
	filePanel1.alt_f1 = true;
	filePanel1.alt_f2 = true;
	filePanel1.alt_f3 = true;
	filePanel1.alt_f4 = true;
	filePanel1.alt_f5 = true;
	filePanel1.alt_f6 = true;
	filePanel1.alt_f7 = true;
	filePanel1.alt_f8 = true;
	filePanel1.alt_f9 = true;
	filePanel1.alt_f10 = true;
	filePanel1.alt_f11 = true;
	filePanel1.alt_f12 = true;
	filePanel1.vk_insert = true;
	filePanel1.vk_plus = true;
	filePanel1.vk_minus = true;
	filePanel1.vk_asterisk = true;

	memcpy(&filePanel2,&filePanel1, sizeof(filePanel1));

	findPanel.f1 = true;
	findPanel.f2 = true;
	findPanel.f3 = true;
	findPanel.f4 = true;
	findPanel.f5 = true;
	findPanel.f6 = true;
	findPanel.f7 = false;
	findPanel.f8 = true;
	findPanel.f9 = false;
	findPanel.f10 = true;
	findPanel.f11 = true;
	findPanel.f12 = true;
	findPanel.ctrl_f1 = true;
	findPanel.ctrl_f2 = true;
	findPanel.ctrl_f3 = true;
	findPanel.ctrl_f4 = true;
	findPanel.ctrl_f5 = true;
	findPanel.ctrl_f6 = true;
	findPanel.ctrl_f7 = true;
	findPanel.ctrl_f8 = true;
	findPanel.ctrl_f9 = true;
	findPanel.ctrl_f10 = true;
	findPanel.ctrl_f11 = true;
	findPanel.ctrl_f12 = true;
	findPanel.alt_f1 = false;
	findPanel.alt_f2 = false;
	findPanel.alt_f3 = true;
	findPanel.alt_f4 = true;
	findPanel.alt_f5 = false;
	findPanel.alt_f6 = false;
	findPanel.alt_f7 = false;
	findPanel.alt_f8 = false;
	findPanel.alt_f9 = false;
	findPanel.alt_f10 = false;
	findPanel.alt_f11 = true;
	findPanel.alt_f12 = true;
	findPanel.vk_insert = true;
	findPanel.vk_plus = true;
	findPanel.vk_minus = true;
	findPanel.vk_asterisk = true;

	netPanel.f1 = true;
	netPanel.f2 = false;
	netPanel.f3 = false;
	netPanel.f4 = false;
	netPanel.f5 = false;
	netPanel.f6 = false;
	netPanel.f7 = false;
	netPanel.f8 = false;
	netPanel.f9 = false;
	netPanel.f10 = true;
	netPanel.f11 = false;
	netPanel.f12 = false;
	netPanel.ctrl_f1 = false;
	netPanel.ctrl_f2 = false;
	netPanel.ctrl_f3 = false;
	netPanel.ctrl_f4 = false;
	netPanel.ctrl_f5 = false;
	netPanel.ctrl_f6 = false;
	netPanel.ctrl_f7 = false;
	netPanel.ctrl_f8 = false;
	netPanel.ctrl_f9 = false;
	netPanel.ctrl_f10 = false;
	netPanel.ctrl_f11 = false;
	netPanel.ctrl_f12 = false;
	netPanel.alt_f1 = false;
	netPanel.alt_f2 = false;
	netPanel.alt_f3 = false;
	netPanel.alt_f4 = false;
	netPanel.alt_f5 = false;
	netPanel.alt_f6 = false;
	netPanel.alt_f7 = false;
	netPanel.alt_f8 = false;
	netPanel.alt_f9 = false;
	netPanel.alt_f10 = false;
	netPanel.alt_f11 = false;
	netPanel.alt_f12 = false;
	netPanel.vk_insert = false;
	netPanel.vk_plus = false;
	netPanel.vk_minus = false;
	netPanel.vk_asterisk = false;

	taskPanel.f1 = true;
	taskPanel.f2 = true;
	taskPanel.f3 = false;
	taskPanel.f4 = true;
	taskPanel.f5 = false;
	taskPanel.f6 = false;
	taskPanel.f7 = false;
	taskPanel.f8 = true;
	taskPanel.f9 = false;
	taskPanel.f10 = true;
	taskPanel.f11 = false;
	taskPanel.f12 = false;
	taskPanel.ctrl_f1 = false;
	taskPanel.ctrl_f2 = false;
	taskPanel.ctrl_f3 = false;
	taskPanel.ctrl_f4 = false;
	taskPanel.ctrl_f5 = false;
	taskPanel.ctrl_f6 = false;
	taskPanel.ctrl_f7 = false;
	taskPanel.ctrl_f8 = false;
	taskPanel.ctrl_f9 = false;
	taskPanel.ctrl_f10 = false;
	taskPanel.ctrl_f11 = false;
	taskPanel.ctrl_f12 = false;
	taskPanel.alt_f1 = false;
	taskPanel.alt_f2 = false;
	taskPanel.alt_f3 = false;
	taskPanel.alt_f4 = false;
	taskPanel.alt_f5 = false;
	taskPanel.alt_f6 = false;
	taskPanel.alt_f7 = false;
	taskPanel.alt_f8 = false;
	taskPanel.alt_f9 = false;
	taskPanel.alt_f10 = false;
	taskPanel.alt_f11 = false;
	taskPanel.alt_f12 = false;
	taskPanel.vk_insert = false;
	taskPanel.vk_plus = false;
	taskPanel.vk_minus = false;
	taskPanel.vk_asterisk = false;

	return true;
}


void KcLog(char *file,char *msg,long l,...)
{
	va_list ap;
	char	fname[STR_SIZE],stmp[100];
	FILE	*f;

//	if(g_kc_debug != 1) return;

	time_t t;
	time(&t);
	struct tm *tmtime = localtime(&t);
	strftime(stmp,99,"%d-%m-%Y %H:%M:%S",tmtime);
	stmp[strlen(stmp)] = 0;

	va_start(ap,l);
//	vsprintf(stmp,str,ap);
	va_end(ap);
	sprintf(fname,"%skc.log",g_start_path);
	f = fopen(fname,"a+");
		fprintf(f,"%s\tmsg: %s value: %ld\n",stmp,msg,l);

	fclose(f);
}

//tests if something changes in directory
BOOL TestPanelChange(TPanel *p,char *path){
	char s_tmp[STR_SIZE];
	WIN32_FIND_DATA c_file;
	HANDLE	hFile;
	long	nFiles=0;
	DWORD	files_size=0;

	sprintf(s_tmp,"%s\\*.*",path);
	if( (hFile = FindFirstFile( s_tmp, &c_file )) != INVALID_HANDLE_VALUE )
	{
		if(strcmp(c_file.cFileName,"."))	{ nFiles++; files_size+=c_file.nFileSizeLow; }
		while( FindNextFile( hFile, &c_file ) == TRUE ) { nFiles++; files_size+=c_file.nFileSizeLow; }
	}
	FindClose( hFile );
	if(nFiles==p->nFiles && files_size==p->panel_size) return FALSE;
	return TRUE;
}

/////////////////////////////////
TPanel tmp_panel={0,0,0,0,0,0,0};
void SavePanelSelectedNames(TPanel *p){
	long i;

	if(tmp_panel.Items != NULL) delete [] tmp_panel.Items;
	//copy panel
	tmp_panel.nFiles = p->nFiles;
	tmp_panel.Items = new TItem[tmp_panel.nFiles];
	kASSERT(tmp_panel.Items!=NULL);
	if(!tmp_panel.Items)	kcerror("Low memory !",__FILE__,__LINE__);

	i = 0;
	tmp_panel.panel_size=0;
	for(i=0;i<p->nFiles;i++) 
	{
		tmp_panel.Items[i].selected = p->Items[i].selected;
		tmp_panel.Items[i].file = p->Items[i].file;
	}
}

void SelectFilesAfterRefresh(TPanel *p){
	long i,j;
	for(i=0;i<tmp_panel.nFiles;i++){
		if(tmp_panel.Items[i].selected){
			for(j=0;j<p->nFiles;j++){
				if(!strcmp(tmp_panel.Items[i].file.cFileName,p->Items[j].file.cFileName)){
					p->Items[j].selected=tmp_panel.Items[i].selected;
					break;
				}
			}
		}
	}
}

void FreePanel(TPanel *p)
{
	if(p->Items != NULL) delete [] p->Items;
	p->Items = NULL;
}

void LoadPanel_old(TPanel *p,char *path)
{
	HANDLE hFile;
	long nFiles = 0;
	long i;
	WIN32_FIND_DATA c_file;
	char s_path[STR_SIZE],stmp[STR_SIZE];

	if(path==NULL) sprintf(s_path,"*.*");
	else sprintf(s_path,"%s\\*.*",path);
	SET_PT(p->pt, PT_NORMAL);

//free memory
	for(i = 0; i < p->nFiles; i++) 
		if(p->Items[i].path) delete [] p->Items[i].path;
	if(p->Items != NULL) delete [] p->Items;

//count files
	if( (hFile = FindFirstFile( s_path, &c_file )) != INVALID_HANDLE_VALUE )
	{
		if(strcmp(c_file.cFileName,"."))	nFiles++;
		while( FindNextFile( hFile, &c_file ) == TRUE ) nFiles++;
	}
	FindClose( hFile );

	p->nFiles = nFiles;
	p->Items = new TItem[nFiles];
	kASSERT(p->Items!=NULL);
	
//load files
	i = 0;
	p->panel_size=0;
	if( (hFile = FindFirstFile( s_path, &c_file )) != INVALID_HANDLE_VALUE )
	{
		if(strcmp(c_file.cFileName,"."))
		{
			p->Items[i].path = NULL;
			p->Items[i].selected = FALSE;
			p->Items[i].dirsize = (DWORD)-1;
			p->Items[i].dircompsize = (DWORD)-1;
			p->Items[i++].file = c_file;
			p->panel_size+=c_file.nFileSizeLow;
		}
		while( FindNextFile( hFile, &c_file ) == TRUE ) 
		{
			if ( i >= nFiles ) break;
			p->Items[i].path = NULL;
			p->Items[i].selected = FALSE;
			p->Items[i].dirsize = (DWORD)-1;
			p->Items[i].dircompsize = (DWORD)-1;
			p->Items[i++].file = c_file;
			p->panel_size+=c_file.nFileSizeLow;
			sprintf(stmp,"[%d]",i);
			FormatStringRight(6,stmp);
			clprintf(GetStdHandle(STD_OUTPUT_HANDLE),ctPanel,cbPanel,71,0,"%s",stmp);
		}
	}
	FindClose( hFile );

}

long realloc_items( TPanel *p, long nItems, long newCount )
{
	char *buffer = new char[ sizeof(TItem) * nItems ];
	kASSERT(buffer!=NULL);
	memcpy( buffer, p->Items, sizeof(TItem) * nItems );
	delete [] p->Items;
	p->Items = new TItem[newCount];
	kASSERT(p->Items!=NULL);
	memset( p->Items, 0,sizeof(TItem) * newCount );
	memcpy( p->Items, buffer,sizeof(TItem) * nItems );
	return newCount;
}

void LoadPanel(TPanel *p,char *path)
{
	HANDLE hFile;
	long nFiles = 0;
	long i;
	WIN32_FIND_DATA c_file;
	char s_path[STR_SIZE],stmp[STR_SIZE];
	HANDLE h = GetStdHandle(STD_OUTPUT_HANDLE);

	if(path==NULL) sprintf(s_path,"*.*");
	else sprintf(s_path,"%s\\*.*",path);
	SET_PT(p->pt, PT_NORMAL);

//free memory
	for(i = 0; i < p->nFiles; i++) {
		if(p->Items[i].path) delete [] p->Items[i].path;
	}
	if(p->Items != NULL) delete [] p->Items;
	p->Items = NULL;

	p->nAllocItems = 100;
	p->Items = new TItem[ p->nAllocItems ];
	kASSERT(p->Items!=NULL);

//load files
	i = 0;
	p->panel_size=0;
	if( (hFile = FindFirstFile( s_path, &c_file )) != INVALID_HANDLE_VALUE )
	{
		if(strcmp(c_file.cFileName,"."))
		{
			p->Items[i].path = NULL;
			p->Items[i].selected = FALSE;
			p->Items[i].dirsize = (DWORD)-1;
			p->Items[i].dircompsize = (DWORD)-1;
			p->Items[i++].file = c_file;
			p->panel_size+=c_file.nFileSizeLow;
		}
		while( FindNextFile( hFile, &c_file ) == TRUE ) 
		{
//			if ( i >= nFiles ) break;
			if( i == p->nAllocItems ) {
				p->nAllocItems += 100;
				realloc_items( p, i, p->nAllocItems );
			}
			p->Items[i].path = NULL;
			p->Items[i].selected = FALSE;
			p->Items[i].dirsize = (DWORD)-1;
			p->Items[i].dircompsize = (DWORD)-1;
			p->Items[i++].file = c_file;
			p->panel_size+=c_file.nFileSizeLow;
			sprintf(stmp,"[%d]",i);
			FormatStringRight(6,stmp);
			clprintf(h,ctPanel,cbPanel,aWindow->posX+aWindow->sizeX - 8,aWindow->posY,"%s",stmp);
		}
		p->nFiles = i;
	} else {
		p->nFiles = 0;
	}
	FindClose( hFile );
}



void LoadFindPanel(TPanel *p,long nFiles)
{
	long i;
	TFind *ff = ffHead.begin,*oldff;

	p->nFiles = nFiles;

	if(p->Items != NULL) delete [] p->Items;
	p->Items = new TItem[nFiles];
	if(!p->Items)	kcerror("Low memory !",__FILE__,__LINE__);
	
	for(i = 0; i < nFiles; i++ )
	{
		p->Items[i].selected = FALSE;
		p->Items[i].dirsize = (DWORD)-1;
		p->Items[i].dircompsize = (DWORD)-1;
		p->Items[i].file = ff->file;
		p->Items[i].path = new char[strlen(ff->path)+1];
		kASSERT(p->Items[i].path!=NULL);
		strcpy(p->Items[i].path,ff->path);
		oldff = ff;
		ff = ff->next;
		delete oldff;
	}
}


BOOL LoadNetPanel(TPanel *p, LPNETRESOURCE nrs)
{
#ifndef _MINGW32_
	long nFiles = 0;
	long i;
	HANDLE h;
	DWORD dwEntries = 0xFFFFFFFF;
	DWORD dwBuffer = 200000;
	DWORD dwResult,dwResultEnum;

	if ( netResource == NULL ) {
		netResource = (LPNETRESOURCE) GlobalAlloc(GPTR, dwBuffer); 
	}

	if ( nrs == NULL ) {
		//free memory
		for(i = 0; i < p->nFiles; i++) 
			if(p->Items[i].path) delete [] p->Items[i].path;
		if(p->Items != NULL) delete [] p->Items;
		////
		dwResult = WNetOpenEnum(RESOURCE_GLOBALNET,RESOURCETYPE_ANY,0,nrs,&h);
		if(dwResult != NO_ERROR) return FALSE;
		do	{
			dwResultEnum = WNetEnumResource(h,&dwEntries,(LPVOID)netResource,&dwBuffer);
			if(dwResultEnum == NO_ERROR) {
				
				p->nFiles = (long)dwEntries;
				p->Items = new TItem[p->nFiles];
				if(!p->Items)	kcerror("Low memory !",__FILE__,__LINE__);
				
				for( i = 0; i < (long)dwEntries; i++) {
					memset(&p->Items[i],0,sizeof(TItem));
					p->Items[i].path = NULL;
					p->Items[i].selected = FALSE;
					p->Items[i].dirsize = (DWORD)-1;
					p->Items[i].dircompsize = (DWORD)-1;
					strcpy(p->Items[i].file.cFileName,netResource[i].lpRemoteName);
					p->Items[i].netrs = &netResource[i];
					p->panel_size=0;
/*					if(RESOURCEDISPLAYTYPE_DOMAIN == netResource[i].dwDisplayType)
						m_l_cDomain.AddString(netResource[i].lpRemoteName);
					if(RESOURCEUSAGE_CONTAINER == (netResource[i].dwUsage & RESOURCEUSAGE_CONTAINER)) {
						if(RESOURCEDISPLAYTYPE_DOMAIN != netResource[i].dwDisplayType)		
							GetDomains(&netResource[i]);
					}*/

				}
			}
		} while (dwResultEnum != ERROR_NO_MORE_ITEMS);
		dwResult = WNetCloseEnum(h); 
	} else  {
		//free memory
		for(i = 0; i < p->nFiles; i++) 
			if(p->Items[i].path) delete [] p->Items[i].path;
		if(p->Items != NULL) delete [] p->Items;
		p->Items = NULL;
		p->nFiles=0;
		////
		dwResult = WNetOpenEnum(RESOURCE_GLOBALNET,RESOURCETYPE_ANY,0,nrs,&h);
		if(dwResult != NO_ERROR) return FALSE;
			dwResultEnum = WNetEnumResource(h,&dwEntries,(LPVOID)netResource,&dwBuffer);
			if(dwResultEnum == NO_ERROR) {
				
				p->nFiles = (long)dwEntries;
				p->Items = new TItem[p->nFiles];
				if(!p->Items)	kcerror("Low memory !",__FILE__,__LINE__);
				
				for( i = 0; i < (long)dwEntries; i++) {
					memset(&p->Items[i],0,sizeof(TItem));
					p->Items[i].path = NULL;
					p->Items[i].selected = FALSE;
					p->Items[i].dirsize = (DWORD)-1;
					p->Items[i].dircompsize = (DWORD)-1;
					strcpy(p->Items[i].file.cFileName,netResource[i].lpRemoteName);
					p->Items[i].netrs = &netResource[i];
					p->panel_size=0;
	/*					if(RESOURCEDISPLAYTYPE_DOMAIN == netResource[i].dwDisplayType)
						m_l_cDomain.AddString(netResource[i].lpRemoteName);
					if(RESOURCEUSAGE_CONTAINER == (netResource[i].dwUsage & RESOURCEUSAGE_CONTAINER)) {
						if(RESOURCEDISPLAYTYPE_DOMAIN != netResource[i].dwDisplayType)		
							GetDomains(&netResource[i]);
					}*/

				}
			} else {
				dwResult = WNetCloseEnum(h); return FALSE;
			}
			dwResult = WNetCloseEnum(h); 
	}

	aWindow->SetLabel("Network");
#endif
return TRUE;
}

void LoadTaskPanel( TPanel *p )
{
	long i;
	char tmp[1000];

	p->curr = 0;
	p->nFiles = REMINDER_MAX_TASKS;
	SET_PT(p->pt, PT_TASK);

	if(p->Items != NULL) delete [] p->Items;
	p->Items = new TItem[REMINDER_MAX_TASKS];
	if(!p->Items)	kcerror("Low memory !",__FILE__,__LINE__);
	
	int n = 0;
	for(i = 0; i < p->nFiles; i++ )
	{
		if( g_task[i].active ) {
			p->Items[n].selected = FALSE;
			p->Items[n].dirsize = (DWORD)-1;
			p->Items[n].dircompsize = i;
			p->Items[n].path = NULL;
			memset( (void*)&p->Items[n].file,0,sizeof(p->Items[n].file));
			sprintf(tmp,"%s   %s",ReminderGetTaskTime1(i),g_task[i].name);
			strcpy(p->Items[n].file.cFileName,tmp);
			p->Items[n].file.nFileSizeLow = g_task[i].tWakeUp;
			p->Items[n].file.nFileSizeHigh = g_task[i].color;
			n++;
		}
	}
	p->nFiles = n;
}



unsigned IsDir(TItem *fd)
{
	return (fd->file.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY);
}


////////////////////////////////////////////
///////////SORT DIRECTORIES/////////////////
////////////////////////////////////////////
int compareSize(const void *elem1,const void *elem2 )
{
	int retVal;
	TItem *fd1 = (TItem*)elem1;
	TItem *fd2 = (TItem*)elem2;

	if(IsDir(fd1) > IsDir(fd2)) return -1;
	if(IsDir(fd1) < IsDir(fd2)) return 1;

	if(IsDir(fd1) && IsDir(fd2))
	{
		//compair dir name
		if(!_stricmp(fd1->file.cFileName,"..")) return -1;
		if(!_stricmp(fd2->file.cFileName,"..")) return 1;
		//compair dir size or name
		if(fd1->dirsize != -1 && fd2->dirsize != -1)
		{
			if(fd1->dirsize == fd2->dirsize) return 0;
			if(fd1->dirsize < fd2->dirsize) return -1;
			return 1;	
		}
		else
		{
			retVal = _stricmp(fd1->file.cFileName,fd2->file.cFileName);
			if(retVal) return retVal;
		}
	}
	else
	{

		if(fd1->file.nFileSizeLow == fd2->file.nFileSizeLow) return 0;
		if(fd1->file.nFileSizeLow < fd2->file.nFileSizeLow) return -1;
		return 1;	
	}
	return 0;
}

int compareTime(const void *elem1,const void *elem2 )
{
	TItem *fd1 = (TItem*)elem1;
	TItem *fd2 = (TItem*)elem2;

	if(IsDir(fd1) > IsDir(fd2)) return -1;
	if(IsDir(fd1) < IsDir(fd2)) return 1;

	if(IsDir(fd1) && IsDir(fd2))
	{
		//compair dir name
		if(_stricmp(fd1->file.cFileName,"..")) return 1;
		if(_stricmp(fd2->file.cFileName,"..")) return -1;
	}
	return (CompareFileTime(&fd1->file.ftLastWriteTime,&fd2->file.ftLastWriteTime));
//	if(fd1->file.ftLastWriteTime == fd2->file.ftLastWriteTime) return 0;
//	if(fd1->file.ftLastWriteTime > fd2->file.ftLastWriteTime) return -1;
//	return 1;	
}


int compareName(const void *elem1,const void *elem2 )
{
	int retVal;
	TItem *fd1 = (TItem*)elem1;
	TItem *fd2 = (TItem*)elem2;
	char *ch1 = fd1->file.cFileName;
	char *ch2 = fd2->file.cFileName;

	//compair name
	retVal = _stricmp(ch1,ch2);
	if(retVal) return retVal;
	return (0);	
}

int compareNameDirFirst(const void *elem1,const void *elem2 )
{
	int retVal;
	TItem *fd1 = (TItem*)elem1;
	TItem *fd2 = (TItem*)elem2;
	if(IsDir(fd1) > IsDir(fd2)) return -1;
	if(IsDir(fd1) < IsDir(fd2)) return 1;

	char *ch1 = fd1->file.cFileName;
	char *ch2 = fd2->file.cFileName;

	//compair name
	retVal = _stricmp(ch1,ch2);
	if(retVal) return retVal;

	return (0);	
}

int compareExtDirFirst(const void *elem1,const void *elem2 )
{
	int retVal;
	TItem *fd1 = (TItem*)elem1;
	TItem *fd2 = (TItem*)elem2;
	if(IsDir(fd1) > IsDir(fd2)) return -1;
	if(IsDir(fd1) < IsDir(fd2)) return 1;

	char *ch1 = fd1->file.cFileName;
	char *ch2 = fd2->file.cFileName;
	//exeption on directory ".."
	if(!stricmp(ch1,"..")) return -1;
	if(!stricmp(ch2,"..")) return 1;
	
	char *ex1 = strchr(fd1->file.cFileName,'.');
	char *ex2 = strchr(fd2->file.cFileName,'.');
	if(!ex1 && ex2) return -1;
	if(ex1 && !ex2) return 1;
	//compair extension
	if(ex1 && ex2)
	{
		retVal = _stricmp(ex1,ex2);
		if(retVal) return retVal;
	}
	//compair name
		retVal = _stricmp(ch1,ch2);
		if(retVal) return retVal;
  return (0);	
}

char g_ext_first[50] = "*.*";

int compareExtDirFirstSpecial(const void *elem1,const void *elem2 )
{
	int retVal;
	TItem *fd1 = (TItem*)elem1;
	TItem *fd2 = (TItem*)elem2;
	char *ex1;
	char *ex2;
	char *ch1 = fd1->file.cFileName;
	char *ch2 = fd2->file.cFileName;
	int sex1 = 1;
	int sex2 = 1;

//exeption on directory ".."
	if(!stricmp(ch1,"..")) return -1;
	if(!stricmp(ch2,"..")) return 1;
	ex1 = strchr(fd1->file.cFileName,'.');
	ex2 = strchr(fd2->file.cFileName,'.');
//special compare
	if(g_ext_first[0] != 0)
	{
		if(ex1) sex1 = stricmp(ex1,g_ext_first);
		if(ex2) sex2 = stricmp(ex2,g_ext_first);
		if(!sex1 && sex2) return -1;
		if(sex1 && !sex2) return 1;
	}
//dir first
	if(IsDir(fd1) > IsDir(fd2)) return -1;
	if(IsDir(fd1) < IsDir(fd2)) return 1;
//is extension exist	
	if(!ex1 && ex2) return -1;
	if(ex1 && !ex2) return 1;
	//compair extension
	if(ex1 && ex2)
	{
		retVal = _stricmp(ex1,ex2);
		if(retVal) return retVal;
	}
	//compair name
		retVal = _stricmp(ch1,ch2);
		if(retVal) return retVal;
	return (0);	
}

int compareExtDirFirstMask(const void *elem1,const void *elem2 )
{
	int retVal;
	TItem *fd1 = (TItem*)elem1;
	TItem *fd2 = (TItem*)elem2;
	char *ex1;
	char *ex2;
	char *ch1 = fd1->file.cFileName;
	char *ch2 = fd2->file.cFileName;
	BOOL mask1;
	BOOL mask2;

//exeption on directory ".."
	if(!stricmp(ch1,"..")) return -1;
	if(!stricmp(ch2,"..")) return 1;
	ex1 = strchr(fd1->file.cFileName,'.');
	ex2 = strchr(fd2->file.cFileName,'.');
//special compare
	if(g_ext_first[0] != 0)
	{
		mask1 = checkname(ch1,g_ext_first);
		mask2 = checkname(ch2,g_ext_first);
		if(!mask1 && mask2) return 1;
		if(mask1 && !mask2) return -1;
	}
//dir first
	if(IsDir(fd1) > IsDir(fd2)) return -1;
	if(IsDir(fd1) < IsDir(fd2)) return 1;
//is extension exist	
	if(!ex1 && ex2) return -1;
	if(ex1 && !ex2) return 1;
	//compair extension
	if(ex1 && ex2)
	{
		retVal = _stricmp(ex1,ex2);
		if(retVal) return retVal;
	}
	//compair name
		retVal = _stricmp(ch1,ch2);
		if(retVal) return retVal;
	return (0);	
}


void SortByName(TItem*& find_data,int nFiles)
{
//	qsort(find_data,nFiles,sizeof(TItem),compareNameDirFirst);
	qsort(find_data,nFiles,sizeof(TItem),compareExtDirFirst);
//	qsort(find_data,nFiles,sizeof(TItem),compareExtDirFirstSpecial);
}

//////////////////////////////////////////
// checkname checks if filename = mask
//
// input	: filename,mask
// return	: if filename = mask TRUE else FALSE
//////////////////////////////////////////
BOOL checkname(char *name,char *mask)
{
	int mi = 0;
	char *p = name;
	BOOL f_second_asterix = FALSE;

	if(!strcmp(mask,"*.*")) return (TRUE);
	if(!strcmp(mask,"*")) return (TRUE);

	for(;;)
	{
		if(*p == 0 && mask[mi]!=0) return (FALSE);
		
		switch(mask[mi])
		{
			case 0 : {
				if( *p == 0) return (TRUE);
				else return (FALSE);
			}
			case '*' : {
				p = strrchr(p,(int)'.');
				if(!p && !strcmp(mask,"*.")) return (TRUE);
				if(!p && f_second_asterix) return (TRUE);
				if(!p && !f_second_asterix) return (FALSE);
				f_second_asterix = TRUE;
				mi++;
				break;
			}				
			case '?' : {
				mi++;
				p++;
				break;				
			}		
			case '.' : {
				if(*p != mask[mi]) return(FALSE);
				mi++;
				p++;
				f_second_asterix = TRUE;
				break;				
			}		
			default : {
				if(toupper(*p) != toupper(mask[mi])) return (FALSE);
				mi++;
				p++;
				break;
			}			
		}//switch
	}//for(
	return (TRUE);
}

//--------------------------------------
// TRUE = mask FALSE = file name
//--------------------------------------
BOOL IsMaskOrFile(char *fname)
{
	if(strchr(fname,'*')) return TRUE;
	if(strchr(fname,'?')) return TRUE;
	
	return FALSE;
}

void CreateFileFromMask(char *mask,char *fname,char *out,int outSize)
{
	char smask[STR_SIZE],sfname[STR_SIZE],stmp[STR_SIZE],smask_path[STR_SIZE];
	int i;
	int mask_size;
	int fname_size;
	int out_pos = 0;
	int fname_pos = 0;
	
	if(!get_2parts_from_end(mask,smask_path,smask,'\\'))
	{
		strcpy(smask_path,"");
	}
	get_2parts_from_end(fname,stmp,sfname,'\\');

	mask_size = strlen(smask);
	fname_size = strlen(sfname);

	memset(out,0,outSize-1);

	for(i = 0; i < mask_size; i++)
	{
		switch(smask[i])
		{
			case '*':
					{
						
						for(; sfname[fname_pos] != 0 && sfname[fname_pos] != '.'; fname_pos++) 
						{
							out[out_pos++] = sfname[fname_pos];
						}
						break;
					}
			case '?':
					{
						out[out_pos++] = sfname[fname_pos++];
						break;
					}
			case '.':
					{
						out[out_pos++] = smask[i];
						for(;sfname[fname_pos] != '.' && sfname[fname_pos] != 0; fname_pos++);
						if(fname_pos < (int)strlen(sfname)) fname_pos++;
						break;
					}
			default:
					{
						out[out_pos++] = smask[i];
						break;
					}

		}
	}
	if(strcmp(smask_path,""))
	{
		strcpy(stmp,out);
		sprintf(out,"%s\\%s",smask_path,stmp);
	}
}

//////////////////////////////////////////
// FormatFileSize
//
// input	: number
// return	: formated string in "str"
//////////////////////////////////////////
void FormatFileSize(double size,char *str)
{
	DWORD giga = (DWORD)(size/1000000000);
	DWORD mega = (DWORD)((DWORD)(size/1000000)%1000);
	DWORD kilo = (DWORD)((DWORD)(size/1000)%1000);
	DWORD byte = (DWORD)((DWORD)(size)%1000);
	if(giga)
	{
		sprintf(str,"%ld,%.3ld,%.3ld,%.3ld",giga,mega,kilo,byte);
		return;
	}
	if(mega)
	{
		sprintf(str,"%ld,%.3ld,%.3ld",mega,kilo,byte);
		return;
	}
	if(kilo)
	{
		sprintf(str,"%ld,%.3ld",kilo,byte);
		return;
	}
	sprintf(str,"%ld",byte);
}

//////////////////////////////////////////
// GetDriveSpace
//
// input	: drive name
// return	: free,total drive space (formated in string)
//			  if drive error FALSE
//////////////////////////////////////////
BOOL GetDriveSpace(char *drive,char *free,char *total)
{
	char tmp[STR_SIZE];
	DWORD dwSectorsPerCluster,dwBytesPerSector,dwFreeClusters,dwClusters;
		
	strcpy(tmp,drive);
	tmp[3] = 0;
	if (GetDiskFreeSpace(tmp,
	  &dwSectorsPerCluster, &dwBytesPerSector,
	  &dwFreeClusters, &dwClusters))
	{
		double d_free = (double)((double)dwBytesPerSector*(double)dwSectorsPerCluster*(double)dwFreeClusters);
		double d_total = (double)((double)dwBytesPerSector*(double)dwSectorsPerCluster*(double)dwClusters);
		FormatFileSize(d_free,free);
		FormatFileSize(d_total,total);
	} 
	else return FALSE;
	
	return TRUE;
}

DWORD GetDriveFreeSpace(char *drive)
{
	char tmp[30];
	DWORD dwSectorsPerCluster,dwBytesPerSector,dwFreeClusters,dwClusters;
		
	memcpy(tmp,drive,3);
	tmp[3] = 0;
	if (GetDiskFreeSpace(tmp,
	  &dwSectorsPerCluster, &dwBytesPerSector,
	  &dwFreeClusters, &dwClusters))
	{
		return (DWORD)(dwBytesPerSector*dwSectorsPerCluster*dwFreeClusters);
	} 
	return 0xFFFFFFFF;
}

void GetDriveTypeMy(char *drive,char *type,char *fstype)
{
   // Variables for processing the volume information
	TCHAR lpVolumeNameBuffer[STR_SIZE];
	DWORD dwVolumeSerialNumber, dwMaximumComponentLength;
	DWORD dwFileSystemFlags;
	TCHAR lpFileSystemNameBuffer[50];	
	
	int	nDriveType;	
	char tmp[10];

	memcpy(tmp,drive,3);
	tmp[3] = 0;

	GetVolumeInformation(tmp,
      lpVolumeNameBuffer,
      ARRAY_SIZE(lpVolumeNameBuffer), &dwVolumeSerialNumber,
      &dwMaximumComponentLength, &dwFileSystemFlags,
      lpFileSystemNameBuffer,
      ARRAY_SIZE(lpFileSystemNameBuffer));
	strcpy(fstype,lpFileSystemNameBuffer);

   nDriveType = GetDriveType(tmp);
   switch (nDriveType) {
	  case 0:
		 strcpy(type,"Error"); //Cannot be determined
		 break;

	  case 1:
		 strcpy(type,"Error");
		 break;

	  case DRIVE_REMOVABLE:
		 strcpy(type,"Removable");
		 break;

	  case DRIVE_FIXED:
		 strcpy(type,"Fixed");
		 break;

	  case DRIVE_REMOTE:
		 strcpy(type,"Remote");
		 break;

	  case DRIVE_CDROM:
		 strcpy(type,"CD-ROM");
		 break;

	  case DRIVE_RAMDISK:
		 strcpy(type,"RAM disk");
		 break;

	  default:
		 strcpy(type,"Unknown");
		 break;
   }

}


//////////////////////////////////////////
// FormatDate
//
// input	: 
// return	: date in string)
//////////////////////////////////////////
void FormatDate(FILETIME *time,char *stime)
{
	SYSTEMTIME sysTime;
	FILETIME   locTime; 

	FileTimeToLocalFileTime(time,&locTime);
	FileTimeToSystemTime(&locTime,&sysTime);
	
	sprintf(stime,"%.2u/%.2u/%.4u",sysTime.wDay,sysTime.wMonth,sysTime.wYear);
}

//////////////////////////////////////////
// FormatTime
//
// input	: 
// return	: time in string)
//////////////////////////////////////////
void FormatTime(FILETIME *time,char *stime)
{
	SYSTEMTIME sysTime;
	FILETIME   locTime; 
	
	_tzset();

	FileTimeToLocalFileTime(time,&locTime);
	FileTimeToSystemTime(&locTime,&sysTime);
	
	sprintf(stime,"%.2u:%.2u:%.2u",sysTime.wHour,sysTime.wMinute,sysTime.wSecond);
}

//////////////////////////////////////////
// CalculateSelectedFiles
//
// input	: panel
// return	: nFiles,size
//////////////////////////////////////////
void CalculateSelectedFiles(TPanel *p,long *n,DWORD *size,BOOL bSelect)
{
	*n = 0;
	if(size) *size = 0;
	for( int i = 0; i < p->nFiles; i++ )
	{
		if(p->Items[i].selected || !bSelect)
		{
			(*n)++;
			if(IsDir(&p->Items[i]) && p->Items[i].dirsize != (DWORD)-1)
			{
				if(size) (*size) += p->Items[i].dirsize;
			}
			else
			{
				if(size) (*size) += p->Items[i].file.nFileSizeLow;
			}
		}
	}
}

//////////////////////////////////////////
// UnselectItems
//
//
//
//////////////////////////////////////////
void UnselectItems(void)
{
	for(int i = 0 ; i < (*aPanel)->nFiles; i++ )
	{
		if(strcmp((*aPanel)->Items[i].file.cFileName,".."))
			(*aPanel)->Items[i].selected = FALSE;
	}
}

//////////////////////////////////////////
// RunProcess (runs new process)
//
// input	: command line,priority
// return	: 
//////////////////////////////////////////
BOOL RunProcess(char *command_line,DWORD priority)
 {
	PROCESS_INFORMATION pi;
	STARTUPINFO si;
	CONSOLE_SCREEN_BUFFER_INFO csbi;
	DWORD	err;
	HANDLE  h_std_out;
	char	s_tmp[1000 + STR_SIZE];

  	si.lpReserved = NULL;
  	si.lpDesktop = NULL;
  	GetStartupInfo(&si);
	memset(&pi,0,sizeof(pi));
  	if((priority&CREATE_NEW_CONSOLE)) si.lpTitle = command_line;

	printf("\n");
	h_std_out = GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleScreenBufferInfo(h_std_out,&csbi);
	
//	l_ftype = TestFile(command_line);
//	if(l_ftype != RUN_FILE_EXE32)
//		sprintf(s_tmp,"cmd /C %s",command_line);
//	else strcpy(s_tmp,command_line); 
	
	strcpy(s_tmp,command_line);
	BOOL pflag = CreateProcess(  NULL,
    				s_tmp,       //command line
                  	NULL,       //process security attr
                  	NULL,       //threat security attr
                  	FALSE,      //inherit handle
                  	priority, //process type and priority
                  	NULL,       //enviroment
                  	NULL,       //curdir
                  	&si, //startup info
                  	&pi);
	
	if(!(priority&CREATE_NEW_CONSOLE)) 
	{
		err = WaitForSingleObject(pi.hProcess,INFINITE);
		if(err == WAIT_FAILED)
		{
			err = GetLastError();
		}
	}
	SetConsoleScreenBufferSize(h_std_out,csbi.dwSize);
	SetConsoleTitle(about);

	printf("\n\n");
	return pflag;
 }

////////////////////////////////////
//GetDrivesInString
//
// return list of drives in string
////////////////////////////////////
char *GetDrivesInString(char *drives)
{
	DWORD	dwNumBytesForDriveStrings;
   	char	lp[STR_SIZE],*p;
   	int		nNumDrives = 0;

	memset(drives,0,40);
   	dwNumBytesForDriveStrings = GetLogicalDriveStrings(0, NULL) * sizeof(TCHAR);

	if (dwNumBytesForDriveStrings != 0) 
	{
	    GetLogicalDriveStrings(99, (LPTSTR)lp);
		p = lp;
		while (*p != 0) 
		{
	        drives[nNumDrives] = (char)toupper(p[0]);
			nNumDrives++;
		    p = strchr(p, 0) + 1;   // Point to next string.
		}
		drives[nNumDrives] = 0;
	}
return drives;
}	

#define		BUFF_SIZE	30000

BOOL FindStringInFile(LPTSTR fname,LPTSTR searchedstring)
{
	char *buffer = NULL;
	size_t strsize = strlen(searchedstring);
	BOOL retVal = FALSE;
	FILE *f;
	long readsize,i;
	
	if( (f = fopen(fname,"rb")) == NULL) return (retVal);
//if file is smaller then string => exit
	fseek(f,0L,SEEK_END);
	readsize = ftell(f);
	if(readsize < (long)strsize) goto Exit;
	fseek(f,0L,SEEK_SET);
	
	buffer = new char[BUFF_SIZE];
	kASSERT(buffer!=NULL);
	for(;;)
	{
		i = ftell(f) - strsize;
		if(i < 0 ) i = 0;
		fseek(f,i,SEEK_SET);
		readsize = fread(buffer,1,BUFF_SIZE,f);
		for(i = 0; i <= (long)(readsize - strsize); i++)
		{
			if(toupper(buffer[i]) == toupper(searchedstring[0]))
			{
				if(!_memicmp((char*)(buffer+i),searchedstring,strsize))
				{
					retVal = TRUE;
					goto Exit;
				}
			}//if(buffer[i] ==
		}//for
		if(readsize < BUFF_SIZE) break;
	}
Exit:
	if(buffer) delete [] buffer;
	fclose(f);
	return (retVal);
}

/////////////////////////////////////////////
/////////// EXT FILE ////////////////////////
/////////////////////////////////////////////

BOOL FindExt(char *name,char *ret,t_ext *fext,int nfext)
{
	int i;
	char *p = strchr(name,(int)'.');
	if(p)
	{
		p++;
		for(i = 0; i < nfext; i++)
		{
			if(!_stricmp(fext[i].ext,p))
			{
				strcpy(ret,fext[i].program);
				return (TRUE);
			}
		}
	}
//find default
	for(i = 0; i < nfext; i++)
	{
		if(!_stricmp(fext[i].ext,"default"))
		{
			strcpy(ret,fext[i].program);
			return (TRUE);
		}
	}

	return (FALSE);
}

//-------------------------------------------
// test file
//-------------------------------------------

long TestFile(char *fname)
{
	char	s_fname[STR_SIZE];
	char	s_tmp[STR_SIZE];
	char	*p;	
	FILE *f;

	f = fopen(fname,"rb");
	if(!f)
	{
//find file in path
		if(FindExecutable(fname,NULL,s_fname) <= (HINSTANCE)32)
		{
			strcpy(s_fname,fname);
			p = strchr(s_fname,(int)' ');
			if(!p) return RUN_FILE_NOT_FOUND;
			else
			{
				*p = 0;
				return TestFile(s_fname);
			}
		}
		f = fopen(s_fname,"rb");
		if(!f)
		{
			p = strchr(s_fname,(int)' ');
			if(!p) return RUN_FILE_NOT_FOUND;
			else
			{
				*p = 0;
				return TestFile(s_fname);
			}
		}
	}
//test FILE
	fread(s_tmp,1,2,f);
	if(!memcmp(s_tmp,"MZ",2))
	{
		fseek(f,0x80,SEEK_SET);
		fread(s_tmp,1,2,f);
		fclose(f);
		if(!memcmp(s_tmp,"PE",2)) return RUN_FILE_EXE32;
		else return RUN_FILE_EXE_DOS;
	}
	else return RUN_FILE_UNKNOWN;
	fclose(f);
return 0;
}
