#ifndef		INPUT_H
#define		INPUT_H
	
#define		INPUT_BUFF_SIZE		1000

#define		TABEND_NO			0x0
#define		TABEND_INIT			0x1
#define		TABEND_RUN			0x2

	class TInput {
	public:		
		char	buffer[INPUT_BUFF_SIZE];
		BOOL	bInsert;
		HANDLE	hCon;
		BOOL	bGotoNextItem;	//CTRL + ENTER - thread	
//for select	
		long	selectedBlockBegin;
		long	selectedBlockEnd;
		long	fixedSelectPoint;
		BOOL	shiftDown;
		BOOL	shiftSelect;
		unsigned bufpos,size;
		int		x,y,startscreen,screenx;
		WORD	bckcolor,textcolor;

		void MoveBuffer(int start,int direct);
		void ShiftBlockSelect(void);
		void DeleteSelected(void);
		void PutToClipboard(void);
		void GetFromClipboard(void);
	
	public:		
		TInput(HANDLE h);
		~TInput();
		
		void SetCursor(DWORD size);
		void gotoxy(int x,int y);
		int Input(char *text,int x,int y,unsigned psize,WORD ct,WORD cb,BOOL bLastKey = FALSE,DWORD dwTabEnd = TABEND_NO);
		int InputFindInPanel(char *text,int x,int y,unsigned psize,WORD ct,WORD cb,DWORD dwTabEnd = TABEND_NO);
		char *GetText(void);
		void SetText(char *text);
	};	

#endif