#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <string.h>
#include "KWindow.h"
#include "Misc.h"
#include "Globals.h"
#include "Input.h"
#include "File.h"

long CreateCommandLine(const TPanel *p,const char *macro,char *cl,const long cl_max_size)
{
	char	*pm = NULL,*pm_last = NULL;
	char	char_set[] = " ";
	char	s_tmp[STR_SIZE];
	int		i;
	BOOL	b_last_round = FALSE;
	int		n_selected = 0;
	HANDLE	hCon = GetStdHandle(STD_OUTPUT_HANDLE);
	KWindow w(hCon);
	TInput	input(hCon);
	
	strcpy(cl,"");
	memcpy(s_tmp,macro,STR_SIZE);
	pm_last = s_tmp;
	pm = strpbrk(s_tmp,char_set);
	*pm = 0;

	while(1)
	{
//copy all selected files to command line
		if(!strnicmp(pm_last,"%SELECTED_",10))
		{
			char *sadd = pm_last+10;
			for(i = 0 ; i < p->nFiles; i++ )
			{
				if(p->Items[i].selected)
				{
					if((long)(strlen(cl) - 1 + strlen(p->Items[i].file.cFileName)) >  cl_max_size) return (cl_max_size + 1);
					strcat(cl,p->Items[i].file.cFileName);
					if(sadd) strcat(cl,sadd);
					strcat(cl," ");
//					p->Items[i].selected = FALSE;
					n_selected++;
				}
			}
			//no file selected use current			
			if(!n_selected)
			{
				strcat(cl,p->Items[p->curr].file.cFileName);
				if(sadd) strcat(cl,sadd);
				strcat(cl," ");
			}
		}
//get input parameter
		else 
			if(!strnicmp(pm_last,"%I_",3))
			{
				w.Init(pm_last+3,10,10,60,3,ctDialog,cbDialog);
				w.SaveBG();
				w.Show(hCon);
				if(input.Input("",12,11,56,ctInput,cbInput) == 13)
				{
					strcat(cl,input.GetText());
					strcat(cl," ");
				}
				w.RestoreBG();
			}
			else
//current name without extension
				if(!stricmp(pm_last,"%CURRNAME"))
				{
					char s_tmp1[STR_SIZE];
					char *tp;

					strcpy(s_tmp1,p->Items[p->curr].file.cFileName);
					tp = strrchr(s_tmp1,'.');
					if(tp) 
					{
						*tp = 0;
						strcat(cl,s_tmp1);
						strcat(cl," ");
					}
				}
				else
				{
					strcat(cl,pm_last);
					strcat(cl," ");
				}
		if(b_last_round) break;
		pm_last = pm + 1;
		pm = strpbrk(pm_last,char_set);
		if(pm) 	*pm = 0;
		else b_last_round = TRUE;
}
return 0;
}