#ifndef		_REMINDER_H_
	
#define		_REMINDER_H_

#define		REMINDER_MAX_TASKS		100

typedef struct _Ttask
{
	time_t			tWakeUp;
	char			name[STR_SIZE];
	char			strTime[50];
	BOOL			active;
	char			color;
	char			email[STR_SIZE];
} Ttask;
	
extern Ttask	g_task[];


int ReminderFindTask(int from);
int ReminderTestTasks(void);
int ReminderAddTask(char *ttime,char *tname, char color, char *email );
void ReminderResetTasks(void);
char* ReminderGetTaskTime(int t);
char* ReminderGetTaskTime1(int t);
char* ReminderGetTaskName(int t);
char* ReminderGetTaskEmail(int t);
char* ReminderGetTaskStrTime(int t);
void ReminderUnactivateTask(int t);
BOOL ReminderSaveTasks(char *fname);
BOOL ReminderLoadTasks(char *fname);

#endif