#include <stdio.h>
#include <conio.h>
#include <process.h>
#include <windows.h>
#include "KWindow.h"
#include "File.h"
#include "Input.h"
#include "Misc.h"
#include "common.h"

#define MAX_TASKS           256

BOOL	bTaskMgrActive = FALSE;

DWORD numTasks;
TASK_LIST tlist[MAX_TASKS];
TASK_LIST_ENUM te;


void TasksFillPanel(TPanel *p)
{
#ifndef _MINGW32_
	long	i = 0;

	p->nFiles = numTasks;
	if(p->Items != NULL) delete [] p->Items;
	p->Items = new TItem[p->nFiles];
	kASSERT(p->Items!=NULL);
	
	for(i = 0; i < p->nFiles; i++ )
	{
		strcpy(p->Items[i].file.cFileName,tlist[i].ProcessName);
		p->Items[i].file.nFileSizeLow = 0;
		p->Items[i].selected = FALSE;
		p->Items[i].dirsize = (DWORD)-1;
		p->Items[i].file.dwFileAttributes = 0;
		p->Items[i].path = NULL;
	}
#endif
}

BOOL LoadTaskList(void)
{
#ifndef _MINGW32_

// Obtain the ability to manipulate other processes
	EnableDebugPriv();

// get the task list for the system
    numTasks = GetTaskList( tlist, MAX_TASKS );
    // enumerate all windows and try to get the window
    // titles for each task
    te.tlist = tlist;
    te.numtasks = numTasks;
    GetWindowTitles( &te );

#endif
return (TRUE);
}